# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::DeploymentManager::Mgmt::V2018_09_01_preview
  module Models
    #
    # Individual resource operation information.
    #
    class ResourceOperation

      include MsRestAzure

      # @return [String] Name of the resource as specified in the artifacts.
      # For ARM resources, this is the name of the resource specified in the
      # template.
      attr_accessor :resource_name

      # @return [String] Unique identifier of the operation. For ARM resources,
      # this is the operationId obtained from ARM service.
      attr_accessor :operation_id

      # @return [String] Type of the resource as specified in the artifacts.
      # For ARM resources, this is the type of the resource specified in the
      # template.
      attr_accessor :resource_type

      # @return [String] State of the resource deployment. For ARM resources,
      # this is the current provisioning state of the resource.
      attr_accessor :provisioning_state

      # @return [String] Descriptive information of the resource operation.
      attr_accessor :status_message

      # @return [String] Http status code of the operation.
      attr_accessor :status_code


      #
      # Mapper for ResourceOperation class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ResourceOperation',
          type: {
            name: 'Composite',
            class_name: 'ResourceOperation',
            model_properties: {
              resource_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'resourceName',
                type: {
                  name: 'String'
                }
              },
              operation_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'operationId',
                type: {
                  name: 'String'
                }
              },
              resource_type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'resourceType',
                type: {
                  name: 'String'
                }
              },
              provisioning_state: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'provisioningState',
                type: {
                  name: 'String'
                }
              },
              status_message: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'statusMessage',
                type: {
                  name: 'String'
                }
              },
              status_code: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'statusCode',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
