# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::DeploymentManager::Mgmt::V2019_11_01_preview
  module Models
    #
    # The resource that defines the source location where the artifacts are
    # located.
    #
    class ArtifactSource < TrackedResource

      include MsRestAzure

      # @return [String] The type of artifact source used.
      attr_accessor :source_type

      # @return [String] The path from the location that the 'authentication'
      # property [say, a SAS URI to the blob container] refers to, to the
      # location of the artifacts. This can be used to differentiate different
      # versions of the artifacts. Or, different types of artifacts like
      # binaries or templates. The location referenced by the authentication
      # property concatenated with this optional artifactRoot path forms the
      # artifact source location where the artifacts are expected to be found.
      attr_accessor :artifact_root

      # @return [Authentication] The authentication method to use to access the
      # artifact source.
      attr_accessor :authentication


      #
      # Mapper for ArtifactSource class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ArtifactSource',
          type: {
            name: 'Composite',
            class_name: 'ArtifactSource',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              tags: {
                client_side_validation: true,
                required: false,
                serialized_name: 'tags',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              location: {
                client_side_validation: true,
                required: true,
                serialized_name: 'location',
                type: {
                  name: 'String'
                }
              },
              source_type: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.sourceType',
                type: {
                  name: 'String'
                }
              },
              artifact_root: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.artifactRoot',
                type: {
                  name: 'String'
                }
              },
              authentication: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.authentication',
                type: {
                  name: 'Composite',
                  polymorphic_discriminator: 'type',
                  uber_parent: 'Authentication',
                  class_name: 'Authentication'
                }
              }
            }
          }
        }
      end
    end
  end
end
