# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::DeploymentManager::Mgmt::V2019_11_01_preview
  module Models
    #
    # Represents the response of a service unit resource.
    #
    class ServiceUnitResource < TrackedResource

      include MsRestAzure

      # @return [String] The Azure Resource Group to which the resources in the
      # service unit belong to or should be deployed to.
      attr_accessor :target_resource_group

      # @return [DeploymentMode] Describes the type of ARM deployment to be
      # performed on the resource. Possible values include: 'Incremental',
      # 'Complete'
      attr_accessor :deployment_mode

      # @return [ServiceUnitArtifacts] The artifacts for the service unit.
      attr_accessor :artifacts


      #
      # Mapper for ServiceUnitResource class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ServiceUnitResource',
          type: {
            name: 'Composite',
            class_name: 'ServiceUnitResource',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              tags: {
                client_side_validation: true,
                required: false,
                serialized_name: 'tags',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              location: {
                client_side_validation: true,
                required: true,
                serialized_name: 'location',
                type: {
                  name: 'String'
                }
              },
              target_resource_group: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.targetResourceGroup',
                type: {
                  name: 'String'
                }
              },
              deployment_mode: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.deploymentMode',
                type: {
                  name: 'Enum',
                  module: 'DeploymentMode'
                }
              },
              artifacts: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.artifacts',
                type: {
                  name: 'Composite',
                  class_name: 'ServiceUnitArtifacts'
                }
              }
            }
          }
        }
      end
    end
  end
end
