# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::DeploymentManager::Mgmt::V2019_11_01_preview
  module Models
    #
    # Detailed information of a specific step run.
    #
    class StepOperationInfo

      include MsRestAzure

      # @return [String] The name of the ARM deployment initiated as part of
      # the step.
      attr_accessor :deployment_name

      # @return [String] Unique identifier to track the request for ARM-based
      # resources.
      attr_accessor :correlation_id

      # @return [DateTime] Start time of the action in UTC.
      attr_accessor :start_time

      # @return [DateTime] End time of the action in UTC.
      attr_accessor :end_time

      # @return [DateTime] Last time in UTC this operation was updated.
      attr_accessor :last_updated_time

      # @return [CloudErrorBody] The errors, if any, for the action.
      attr_accessor :error


      #
      # Mapper for StepOperationInfo class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'StepOperationInfo',
          type: {
            name: 'Composite',
            class_name: 'StepOperationInfo',
            model_properties: {
              deployment_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'deploymentName',
                type: {
                  name: 'String'
                }
              },
              correlation_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'correlationId',
                type: {
                  name: 'String'
                }
              },
              start_time: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'startTime',
                type: {
                  name: 'DateTime'
                }
              },
              end_time: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'endTime',
                type: {
                  name: 'DateTime'
                }
              },
              last_updated_time: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'lastUpdatedTime',
                type: {
                  name: 'DateTime'
                }
              },
              error: {
                client_side_validation: true,
                required: false,
                serialized_name: 'error',
                type: {
                  name: 'Composite',
                  class_name: 'CloudErrorBody'
                }
              }
            }
          }
        }
      end
    end
  end
end
